diff a/hat/whitespacecheck.bash b/hat/whitespacecheck.bash
--- /dev/null
+++ b/hat/whitespacecheck.bash
@@ -0,0 +1,55 @@
+#!/bin/bash
+cat >/dev/null<<LICENSE
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+LICENSE
+
+echo spaces at end of lines
+find . \
+   -name "*.iml" \
+   -o -name "*.bash" \
+   -o -name "*.xml" \
+   -o -name "*.java" \
+   -o -name "*.h" \
+   -o -name "*.md" \
+   -o -name "*.cpp" \
+   -o -name CMakeFiles.list \
+   | xargs grep "  *$" \
+   | cut -d: -f1 \
+   | sort -u
+
+echo tabs
+find . \
+   -name "*.iml" \
+   -o -name "*.bash" \
+   -o -name "*.xml" \
+   -o -name "*.java" \
+   -o -name "*.h" \
+   -o -name "*.md" \
+   -o -name "*.cpp" \
+   -o -name CMakeFiles.list \
+   | xargs grep "\t" \
+   | cut -d: -f1 \
+   | sort -u
